#include "ZusatzAufgaben_epr_03.h"
#include "Aufgabe_3_epr_03.h"
#include "Hilfen.h"
#include <stdio.h>
#include <stdlib.h>

int getAnzahlTageImMonat(int nMonat, int nJahr)
{
	int ntageImMonat = tageImMonat(nMonat);
	int nSchaltjahrFebruar = ((isSchaltjahr(nJahr) == 1 && nMonat == 2) ? 1 : 0);
	int nReturnValue = (ntageImMonat + nSchaltjahrFebruar);
	return nReturnValue;
}

int getAnzahlTageImJahr(int nJahr)
{
	return (isSchaltjahr(nJahr) == 1) ? 366 : 365;
}

int getTagDesJahres(int nTag, int nMonat, int nJahr)
{
	if ((nMonat < 0) || (nMonat > 12))
	{
		return -1;
	}

	int nLokalTag = nTag;
	int nLokalMonat = nMonat;

	while (nLokalMonat > 1)
	{
		nLokalMonat--;
		nLokalTag += getAnzahlTageImMonat(nLokalMonat, nJahr);
	}

	return nLokalTag;
}

int getDaysToDate(int nTagVon, int nMonatVon, int nJahrVon, int nTagBis, int nMonatBis, int nJahrBis)
{
	if (nJahrBis == nJahrVon)
	{
		int nErgebnis = getTagDesJahres(nTagBis, nMonatBis, nJahrBis) - getTagDesJahres(nTagVon, nMonatVon, nJahrVon);
		return nErgebnis;
	}
	else if (nJahrBis > nJahrVon)
	{
		// Wir starten mit der Anzahl Tage im Endejahr:
		int nErgebnis = getTagDesJahres(nTagBis, nMonatBis, nJahrBis);

		int nJahr = nJahrBis - 1;

		// Jetzt summieren wir alle dazwischenliegenden Jahre:
		while (nJahr > nJahrVon)
		{
			nErgebnis += getAnzahlTageImJahr(nJahr);
			nJahr--;
		}

		// und addieren schlielich noch die Anzahl der Tage aus dem Start - Jahr:
		nErgebnis += (getAnzahlTageImJahr(nJahrVon)
			- getTagDesJahres(nTagVon,
			nMonatVon, nJahrVon));

		return nErgebnis;
	}
	else
	{
		int nErgebnis = getDaysToDate(nTagBis, nMonatBis, nJahrBis, nTagVon, nMonatVon, nJahrVon) * (-1);
		return nErgebnis;
	}
}
//Quelle http://de.wikipedia.org/wiki/Gau%C3%9Fsche_Osterformel
int getOsterSonntag(int nJahr)
{
	int a = nJahr % 19;
	int b = nJahr % 4;
	int c = nJahr % 7;
	int k = nJahr / 100;
	int p = (8 * k + 13) / 25;
	int q = k / 4;
	int M = (15 + k - p - q) % 30;
	int N = (4 + k - q) % 7;
	int d = (19 * a + M) % 30;
	int e = ((2 * b) + (4 * c) + (6 * d) + N) % 7;
	int nOsterSonntag = (22 + d + e);
	return nOsterSonntag;
}

void zusatzAufgabe_TageBisWeihnachten(void)
{
	int nTag = 1;
	int nMonat = 1;
	int nJahr = 2000;
	int nTageBisWeihnachten = 0;
	readInt(&nTag, "Bitte einen Tag eingeben:");
	printf_s("\n");
	readInt(&nMonat, "Bitte einen Monat eingeben:");
	printf_s("\n");
	readInt(&nJahr, "Bitte einen Jahr eingeben:");
	printf_s("\n");

	if (pruefeDatum(nTag, nMonat, nJahr) == 1)
	{
		if (nMonat < 12 && nTag < 25)
		{
			nTageBisWeihnachten = getDaysToDate(nTag, nMonat, nJahr, 24, 12, nJahr);
		}
		else
		{
			nJahr++;
			nTageBisWeihnachten = getDaysToDate(nTag, nMonat, nJahr, 24, 12, nJahr);
		}

		printf_s("Noch %i Tage bis Weihnachten.\n", nTageBisWeihnachten);
	}
	else
	{
		printf_s("Bitte \x81 \bberpr\x81 \bfen Sie ihre eingegebenen Daten...\n");
	}
}

void zusatzAufgabe_DatumsDifferenz(void)
{
	int nTagVon = 1;
	int nMonatVon = 1;
	int nJahrVon = 2000;
	int nTagBis = 1;
	int nMonatBis = 1;
	int nJahrBis = 2000;
	int nTagesDiff = 0;
	readInt(&nTagVon, "Bitte einen Starttag eingeben:");
	printf_s("\n");
	readInt(&nMonatVon, "Bitte einen Startmonat eingeben:");
	printf_s("\n");
	readInt(&nJahrVon, "Bitte ein Startjahr eingeben:");
	printf_s("\n");
	readInt(&nTagBis, "Bitte einen Endtag eingeben:");
	printf_s("\n");
	readInt(&nMonatBis, "Bitte einen Endmonat eingeben:");
	printf_s("\n");
	readInt(&nJahrBis, "Bitte ein Endjahr eingeben:");
	printf_s("\n");
	if (pruefeDatum(nTagVon, nMonatVon, nJahrVon) == 1 && pruefeDatum(nTagBis, nMonatBis, nJahrBis) == 1)
	{
		nTagesDiff = getDaysToDate(nTagVon, nMonatVon, nJahrVon, nTagBis, nMonatBis, nJahrBis);
		printf_s("%02i.%02i.%04i bis %02i.%02i.%04i  %4i Tag%c\n", nTagVon, nMonatVon, nJahrVon, nTagBis, nMonatBis, nJahrBis, nTagesDiff, nTagesDiff > 1 ? 'e' : ' ');
	}
	else
	{
		printf_s("Bitte \x81 \bberpr\x81 \bfen Sie ihre eingegebenen Daten...\n");
	}

	
	
}

void zusatzAufgabe_Ostersonntag(void)
{
	int nJahr = 0;
	readInt(&nJahr, "Bitte geben Sie ein Jahr ein:");
	int nOsterSonntag = getOsterSonntag(nJahr);
	char *monat = nOsterSonntag > 31 ? "April" : "M\x84rz";
	printf_s("Ostern ist am %02i. %5s im Jahr %i\n", nOsterSonntag > 31 ? nOsterSonntag - 31 : nOsterSonntag, monat, nJahr);

}

void zusatzAufgabe_TageBisWeihnachtenKontrolle(void)
{
	int nTest = getDaysToDate(19, 11, 2013, 24, 12, 2013);
	printf_s("Noch %i Tage bis Weihnachten.\n", nTest);
	nTest = getDaysToDate(18, 11, 2013, 24, 12, 2013);
	printf_s("Noch %i Tage bis Weihnachten.\n", nTest);
	nTest = getDaysToDate(19, 12, 2013, 24, 12, 2013);
	printf_s("Noch %i Tage bis Weihnachten.\n", nTest);
	nTest = getDaysToDate(15, 15, 2013, 24, 12, 2013);
	printf_s("Noch %i Tage bis Weihnachten.\n", nTest);
	nTest = getDaysToDate(19, 7, 2013, 24, 12, 2014);
	printf_s("Noch %i Tage bis Weihnachten.\n", nTest);
	nTest = getDaysToDate(19, 11, 2013, 24, 12, 2014);
	printf_s("Noch %i Tage bis Weihnachten.\n", nTest);
}

void zusatzAufgabe_DatumsDifferenzKontrolle(void)
{
	int nTest = getDaysToDate(19, 11, 2013, 20, 11, 2013);
	printf_s("%02i.%02i.%04i bis %02i.%02i.%04i  %4i Tag%c\n", 19, 11, 2013, 20, 11, 2013, nTest, nTest > 1 ? 'e' : ' ');
	nTest = getDaysToDate(19, 11, 2013, 18, 11, 2013);
	printf_s("%02i.%02i.%04i bis %02i.%02i.%04i  %4i Tag%c\n", 19, 11, 2013, 18, 11, 2013, nTest, nTest > 1 ? 'e' : ' ');
	nTest = getDaysToDate(19, 11, 2013, 19, 12, 2013);
	printf_s("%02i.%02i.%04i bis %02i.%02i.%04i  %4i Tag%c\n", 19, 11, 2013, 19, 12, 2013, nTest, nTest > 1 ? 'e' : ' ');
	nTest = getDaysToDate(19, 11, 2013, 24, 12, 2013);
	printf_s("%02i.%02i.%04i bis %02i.%02i.%04i  %4i Tag%c\n", 19, 11, 2013, 24, 12, 2013, nTest, nTest > 1 ? 'e' : ' ');
	nTest = getDaysToDate(19, 11, 2013, 19, 11, 2014);
	printf_s("%02i.%02i.%04i bis %02i.%02i.%04i  %4i Tag%c\n", 19, 11, 2013, 19, 11, 2014, nTest, nTest > 1 ? 'e' : ' ');
	nTest = getDaysToDate(19, 11, 2013, 24, 12, 2014);
	printf_s("%02i.%02i.%04i bis %02i.%02i.%04i  %4i Tag%c\n", 19, 11, 2013, 24, 12, 2014, nTest, nTest > 1 ? 'e' : ' ');
}

void zusatzAufgabe_OstersonntagKontrolle(void)
{
	int nJahr = 0;
	for (nJahr = 2010; nJahr <= 2013; nJahr++)
	{
		int nOsterSonntag = getOsterSonntag(nJahr);
		char *monat = nOsterSonntag > 31 ? "April" : "M\x84rz";
		printf_s("Ostern ist am %02i. %5s im Jahr %i\n", nOsterSonntag > 31 ? nOsterSonntag - 31 : nOsterSonntag, monat, nJahr);
	}
}